Subject: educational challenges to improving IETF diversity and inclusiveness

From: Greg Skinner <[email-masked]>
Date: Fri, 4 Feb 2022 10:47:58 -0800

In their latest diversity and inclusiveness draft <https://datatracker.ietf.org/doc/html/draft-gont-diversity-analysis>, the authors have identified some challenges in getting newcomers better able to participate in the IETF, such as knowledge of mature IETF protocols, and the ability to assess protocols critically.  They recommended two textbooks that can help here.  I have two more suggestions, and am interested in other resources that could be useful in this regard.

Principles of Computer System Design: An Introduction <https://ocw.mit.edu/resources/res-6-004-principles-of-computer-system-design-an-introduction-spring-2009/> (Saltzer, Kaashoek)
Computer Networks: A Systems Approach <https://book.systemsapproach.org/> (Peterson, Davie)

In addition to communications protocols, both books cover principles of security and some of the analytic techniques used to assess network performance.  Several chapters from the first textbook, and all of the second textbook, are online.  Also, Saltzer has been an influence on many key IETF contributors, historically.

If you feel there is a better list for this discussion (such as the diversity list, which has been inactive for over three years), please provide your suggestions.

Regards, Greg

---

From: Brian E Carpenter <[email-masked]>
Date: Sat, 5 Feb 2022 08:52:57 +1300

Greg,

I'd take it to https://www.ietf.org/mailman/listinfo/edu-discuss

Also see https://datatracker.ietf.org/group/emodir/about/ because this topic is their job.

Regards
    Brian Carpenter

On 05-Feb-22 07:47, Greg Skinner wrote:
> In their latest diversity and inclusiveness draft <https://datatracker.ietf.org/doc/html/draft-gont-diversity-analysis>, the authors have identified some challenges in getting newcomers better able to participate 
in the IETF, such as knowledge of mature IETF protocols, and the ability to assess protocols critically.  They recommended two textbooks that 
can help here.  I have two more suggestions, and am interested in other resources that could be useful in this regard.
> In addition to communications protocols, both books cover principles of 
security and some of the analytic techniques used to assess network performance.  Several chapters from the first textbook, and all of the second textbook, are online.  Also, Saltzer has been an influence 
on many key IETF contributors, historically.

---

From: "[email-masked]" <[email-masked]>
Date: Sat, 5 Feb 2022 10:30:06 -0800

Other common texts include the following:

o   Computer Networking: A Top-Down Approach, Kurose/Ross (Pearson/Addison-Wesley)

o   Computer Networks, Tannenbaum/Feamster/Weatherall (Pearson/Prentice-Hall)

o   Computer Networks and Internets, Comer (Pearson/Prentice-Hall)

All these are subtly different, but all are widely used.

Joe

—
Joe Touch, temporal epistemologist
www.strayalpha.com

> On Feb 4, 2022, at 10:47 AM, Greg Skinner <gregskinner0=[email-masked]> wrote:
>

---

From: Lloyd W <[email-masked]>
Date: Sun, 6 Feb 2022 12:50:15 +1100

I recommend the second edition of Tanenbaum (note spelling) for giving a clear, structured view of decomposition of functionality and layering, with a range of protocols as examples.

Later editions were rewritten to describe a grab bag of protocols in the IP suite, badly. Thank the added co-authors.

Lloyd Wood
[email-masked]

> On 6 Feb 2022, at 05:31, [email-masked] wrote:
> 
>> In their latest diversity and inclusiveness draft, the authors have identified some challenges in getting newcomers better able to participate in the IETF, such as knowledge of mature IETF protocols, and the ability to assess protocols critically.  They recommended two textbooks that can help here.  I have two more suggestions, and am interested in other resources that could be useful in this regard.
>> 
>> Principles of Computer System Design: An Introduction (Saltzer, Kaashoek)
>> Computer Networks: A Systems Approach (Peterson, Davie)
>>

---

From: "[email-masked]" <[email-masked]>
Date: Sat, 5 Feb 2022 18:17:32 -0800

My apologies for the misspelling.

There are many editions of the books below, but only the most recent is currently in print; they are vary quite a bit, as Lloyd noted.

Other books that are out of print, but useful if you can find:

Bersekas/Gallager - Data Networks
Halsall - Computer Networking and the Internet

I also strongly recommend another, still in print:

	Shannon/Weaver - The Mathematical Theory of Communication

Joe

—

> On Feb 5, 2022, at 5:50 PM, Lloyd W <[email-masked]> wrote:
> 
>> www.strayalpha.com <http://www.strayalpha.com/>
>> 
>>> On Feb 4, 2022, at 10:47 AM, Greg Skinner <gregskinner0=[email-masked] <mailto:gregskinner0=[email-masked]>> wrote:
>>>

---

From: Greg Skinner <[email-masked]>
Date: Sun, 6 Feb 2022 13:27:09 -0800

Bertsekas/Gallager is available <https://web.mit.edu/dimitrib/www/datanets.html> via Bertsekas’ MIT home page.  (Some pages may be difficult to read.)

A data communication networks class taught at MIT <https://web.mit.edu/modiano/www/6.263/> using Bertsekas/Gallager lists Peterson/Davie and Tanenbaum as supplemental reading.

Greg

> On Feb 5, 2022, at 6:17 PM, [email-masked] wrote:
> 
>> On Feb 5, 2022, at 5:50 PM, Lloyd W <[email-masked] <mailto:[email-masked]>> wrote:
>> 
>> [email-masked] <mailto:[email-masked]>
>> 
>>> On 6 Feb 2022, at 05:31, [email-masked] <mailto:[email-masked]> wrote:
>>>

---

From: Marc Petit-Huguenin <[email-masked]>
Date: Sun, 6 Feb 2022 15:41:13 -0800

And to be sure that these beginners keep an open mind, let's add

Day J. Patterns in Network Architecture: A Return to Fundamentals. Upper Saddle River, NJ: Prentice Hall; 2008. 429 p.

-- 
Marc Petit-Huguenin
Email: [email-masked]
Blog: https://marc.petit-huguenin.org
Profile: https://www.linkedin.com/in/petithug

---

From: Joe Touch <[email-masked]>
Date: Sun, 6 Feb 2022 15:56:24 -0800

A fine book, but not a textbook.  There are other good books that are not textbooks too. 

Joe

> On Feb 6, 2022, at 3:41 PM, Marc Petit-Huguenin <[email-masked]> wrote:
>

---

From: "Joel M. Halpern" <[email-masked]>
Date: Sun, 6 Feb 2022 19:19:47 -0500

While I like a lot of the material in John's book, I think it is more 
likely to confuse rather than help a beginner.

Yours,
Joel

On 2/6/2022 6:41 PM, Marc Petit-Huguenin wrote:
> Day J. Patterns in Network Architecture: A Return to Fundamentals. Upper 
> Saddle River, NJ: Prentice Hall; 2008. 429 p.
> 
>> Bertsekas/Gallager is available 
>> <https://web.mit.edu/dimitrib/www/datanets.html> via Bertsekas’ MIT 
>> home page.  (Some pages may be difficult to read.)
>>
>> A data communication networks class taught at MIT 
>> <https://web.mit.edu/modiano/www/6.263/> using Bertsekas/Gallager 
>> lists Peterson/Davie and Tanenbaum as supplemental reading.
>>
>> Greg
>>
>>> There are many editions of the books below, but only the most recent 
>>> is currently in print; they are vary quite a bit, as Lloyd noted.
>>>
>>>> I recommend the second edition of Tanenbaum (note spelling) for 
>>>> giving a clear, structured view of decomposition of functionality 
>>>> and layering, with a range of protocols as examples.
>>>>
>>>> Later editions were rewritten to describe a grab bag of protocols in 
>>>> the IP suite, badly. Thank the added co-authors.
>>>>
>>>> Lloyd Wood
>>>>>> On Feb 4, 2022, at 10:47 AM, Greg Skinner 
>>>>>> <gregskinner0=[email-masked] 
>>>>>> <mailto:gregskinner0=[email-masked]>> wrote:
>>>>>>
>>>>>> In their latest diversity and inclusiveness draft 
>>>>>> <https://datatracker.ietf.org/doc/html/draft-gont-diversity-analysis>, 
>>>>>> the authors have identified some challenges in getting newcomers 
>>>>>> better able to participate in the IETF, such as knowledge of 
>>>>>> mature IETF protocols, and the ability to assess protocols 
>>>>>> critically.  They recommended two textbooks that can help here.  I 
>>>>>> have two more suggestions, and am interested in other resources 
>>>>>> that could be useful in this regard.
>>>>>>
>>>>>> Principles of Computer System Design: An Introduction 
>>>>>> <https://ocw.mit.edu/resources/res-6-004-principles-of-computer-system-design-an-introduction-spring-2009/> 
>>>>>> (Saltzer, Kaashoek)
>>>>>> Computer Networks: A Systems Approach 
>>>>>> <https://book.systemsapproach.org/> (Peterson, Davie)
>>>>>>
>>>>>> In addition to communications protocols, both books cover 
>>>>>> principles of security and some of the analytic techniques used to 
>>>>>> assess network performance.  Several chapters from the first 
>>>>>> textbook, and all of the second textbook, are online.  Also, 
>>>>>> Saltzer has been an influence on many key IETF contributors, 
>>>>>> historically.
>>>>>>
>>>>>> If you feel there is a better list for this discussion (such as 
>>>>>> the diversity list, which has been inactive for over three years), 
>>>>>> please provide your suggestions.
>>>>>>
>>>>>> Regards, Greg
>>>>>>
>>>>>
>>>
>>
>>
> 
>

---

From: Warren Kumari <[email-masked]>
Date: Tue, 8 Feb 2022 09:42:19 -0500

> Saddle River, NJ: Prentice Hall; 2008. 429 p.

Many of the books that have been recommended are, IMO, quite heavy reading.
They are certainly good, and worth the time, but handing a newcomer a big
pile of dense academic textbooks seems like it will turn them off.

Previously, when I hired relatively newcomers to network operations, I'd
buy them two books:
1: "BGP4: Inter-Domain Routing in the Internet: Inter-Domain Routing in the
Internet"  by John W. Stewart  - https://amzn.to/3GEYbkm
2: "Internet Routing Architectures" by Sam Halabi - https://amzn.to/3LmltyX

Both of them are somewhat dated now (~2000), but both are still relevant.
BGP4 is really short and friendly, and are "non-scary" introduction to BGP
routing.

"Internet Routing Architectures", which, like Cher or Madonna or Sting was
sufficiently well known that everyone would just call it "the Halabi book"
is a classic. It is much broader than BGP4, but is still very friendly and
approachable.

Sure, there are other books which are important, and probably more
important to read to be able to design a perfect protocol -- but, this
started off as a discussion to "get newcomers better able to participate",
and I believe that 99.9% of that is simply helping them to be interested
and willing, and so I think that "interesting, friendly, approachable" is
more important than strict theory.

Actually, I think that the most important "book" then is "RFC1925 - The
Twelve Networking Truths" by R Callon -
https://datatracker.ietf.org/doc/html/rfc1925
This really does encapsulate much of what is needed to participate.

In a similar vein, "RFC5218 - What Makes for a Successful Protocol?" -
https://datatracker.ietf.org/doc/html/rfc5218

Yes, having formal knowledge is useful, and reading the textbooks is good -
but, being *interested* and willing to learn is, IMO, more important.
W

> > Bertsekas/Gallager is available <
> https://web.mit.edu/dimitrib/www/datanets.html> via Bertsekas’ MIT home
> page.  (Some pages may be difficult to read.)
> >
> > A data communication networks class taught at MIT <
> https://web.mit.edu/modiano/www/6.263/> using Bertsekas/Gallager lists
> Peterson/Davie and Tanenbaum as supplemental reading.
> >
> > Greg
> >
> >> There are many editions of the books below, but only the most recent is
> currently in print; they are vary quite a bit, as Lloyd noted.
> >>
> >>> I recommend the second edition of Tanenbaum (note spelling) for giving
> a clear, structured view of decomposition of functionality and layering,
> with a range of protocols as examples.
> >>>
> >>>>> On Feb 4, 2022, at 10:47 AM, Greg Skinner <gregskinner0=
> [email-masked] <mailto:gregskinner0=
> [email-masked]>> wrote:
> >>>>>
> >>>>> In their latest diversity and inclusiveness draft <
> https://datatracker.ietf.org/doc/html/draft-gont-diversity-analysis>, the
> authors have identified some challenges in getting newcomers better able to
> participate in the IETF, such as knowledge of mature IETF protocols, and
> the ability to assess protocols critically.  They recommended two textbooks
> that can help here.  I have two more suggestions, and am interested in
> other resources that could be useful in this regard.
> >>>>>
> >>>>> Principles of Computer System Design: An Introduction <
> https://ocw.mit.edu/resources/res-6-004-principles-of-computer-system-design-an-introduction-spring-2009/>
> (Saltzer, Kaashoek)
> >>>>> Computer Networks: A Systems Approach <
> https://book.systemsapproach.org/> (Peterson, Davie)
> >>>>>
> >>>>> In addition to communications protocols, both books cover principles
> of security and some of the analytic techniques used to assess network
> performance.  Several chapters from the first textbook, and all of the
> second textbook, are online.  Also, Saltzer has been an influence on many
> key IETF contributors, historically.
> >>>>>
> >>>>> If you feel there is a better list for this discussion (such as the
> diversity list, which has been inactive for over three years), please
> provide your suggestions.
> >>>>>
> >>>>> Regards, Greg
> >>>>>
> >>>>
> >>
> >
> >
>
>
> --
> Marc Petit-Huguenin

-- 
The computing scientist’s main challenge is not to get confused by the
complexities of his own making.
  -- E. W. Dijkstra

---

From: Marc Petit-Huguenin <[email-masked]>
Date: Tue, 8 Feb 2022 07:00:45 -0800

> pile of dense academic textbooks seems like it will turn them off.

Then a good, modern, and relevant place to start may be:

1. Article 19, Uhlig U, Knodel M, Oever N ten, Cath-Speth C, editors. How the internet really works: an illustrated guide to protocols, privacy, censorship, and governance. San Francisco: No Starch Press; 2021. 106 p.

---

From: Greg Skinner <[email-masked]>
Date: Tue, 8 Feb 2022 15:08:11 -0800

> On Feb 8, 2022, at 6:42 AM, Warren Kumari <[email-masked]> wrote:
> 
> 
> 
> On Sun, Feb 6, 2022 at 6:41 PM Marc Petit-Huguenin <[email-masked] <mailto:[email-masked]>> wrote:
> Many of the books that have been recommended are, IMO, quite heavy reading. They are certainly good, and worth the time, but handing a newcomer a big pile of dense academic textbooks seems like it will turn them off.
> 
To be clear, I was referring to “newcomers” in the context of §10 of draft-gont-diversity-analysis-01 <https://datatracker.ietf.org/doc/html/draft-gont-diversity-analysis-01#section-10>.  In particular, I was thinking of the difficulty some people have in getting their drafts published, or even (informally) asking if certain protocol additions or modifications are something the IETF would pursue.  The concepts and principles presented in the books I gave as examples are useful in explaining why decisions are (or aren’t) made.  There are certainly “newcomers” for whom these books would be overkill.

Also, except for one (Saltzer/Kaashoek), the books I gave as examples are available for free online.  (About half of Saltzer/Kaashoek is available for free online.)  So if there is a need for anyone to reference these books, all she or he needs is working Internet access, a web browser, and a pdf reader.

Regards, Greg

---

From: Abdussalam Baryun <[email-masked]>
Date: Thu, 10 Feb 2022 17:12:35 +0200

Hi Greg,

Thanks alot, I agree with you,

On Fri, Feb 4, 2022 at 8:48 PM Greg Skinner <gregskinner0=
[email-masked]> wrote:

> <https://datatracker.ietf.org/doc/html/draft-gont-diversity-analysis>, the
> <https://ocw.mit.edu/resources/res-6-004-principles-of-computer-system-design-an-introduction-spring-2009/> (Saltzer,
> Kaashoek)
> security and some of the analytic techniques used to assess network

No much time, most experts are busy,,,, I don't think
books/papers/standards is the issue, the newcomer needs more open
environment/community/WG or more guidance. However, there needs to be some
effort from management in discussions.

> provide your suggestions.

my suggestion that it is the right place, making a list for diversity may
not improve it, the lists are done for improving progress/solutions. We
need to identify the problem.
There are participants (I am not sure of my opinion yet, before I was, but
changed expectations) that don't think there is a problem or importance.
The diversity list which I was participating on was not active maybe
because no director, within all IETF efforts we need a director or
motivator to make input/volunteer, the importance of any effort needs to
get value from participants or director. I lost my opinions or interest
because no motivator or no time or no shown interest from IETF.

 Engineers may get busy in other issues if no community-interest or value
in-progressing.

Regards
AB